<?php

namespace App\Models;

use App\Traits\HasTranslations;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;

class Project extends Model
{
    use HasTranslations;
    protected $fillable = [
        'slug',
        'title_key',
        'description_key',
        'short_description_key',
        'image',
        'url',
        'github_url',
        'date_completed',
        'is_featured',
        'display_order',
    ];

    protected function casts(): array
    {
        return [
            'date_completed' => 'date',
            'is_featured' => 'boolean',
        ];
    }

    public function skills(): BelongsToMany
    {
        return $this->belongsToMany(Skill::class, 'skill_project')
            ->withPivot(['level_before', 'level_after', 'level_description_key'])
            ->withTimestamps();
    }

    public function scopeFeatured(Builder $query): Builder
    {
        return $query->where('is_featured', true);
    }

    public function scopeOrdered(Builder $query): Builder
    {
        return $query->orderBy('display_order');
    }
}
